Name:           nagvis
Version:        1.9.16
Release:        0.1%{?dist}
License:        GPLv2
Summary:        Visualization addon for Nagios
Group:          Productivity/Networking/Web/Utilities
Url:            http://www.nagvis.org/
Source:         http://www.nagvis.org/share/%name-%version.tar.gz
Source1:        nagvis-rpmlintrc
Source2:        nagvis-include.conf
Source3:        nagvis-update-script.sh
Source4:        nagvis-update-script.1
Source5:        nagvis-README.SuSE
Source6:        nagvis-make-admin.1
# PATCH-MISSING-TAG -- See http://en.opensuse.org/Packaging/Patches
Patch1:         nagvis-make-admin.patch
# PATCH-MISSING-TAG -- See http://en.opensuse.org/Packaging/Patches
Patch2:         nagvis-config.patch
BuildRequires:  httpd-devel
BuildArch:      noarch
# gd mbstring gettext session xml pdo
Requires:       graphviz
Requires:       nagios
Requires:       php-ZendFramework
Requires:       php-gd
Requires:       php-gettext
#Requires:       php-json (Builtin since PHP 5.2)
Requires:       php-mbstring
Requires:       php-pdo
Requires:       php-sockets
Requires:       php-session
#Requires:       pdo-sqlite
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
NagVis can be used to visualize Nagios Data, e.g. to display IT
processes like a mail system or a network infrastructure.

Key features are:
    * Display of single Hosts and Services
    * Visualize a complete Host- or Servicegroup with one icon
    * Display the state of a Host dependent on the state of
      its services (“recognize services”)
    * Display only the real problems (“only_hard_states”)
    * Define Sub-Map icons which represent a complete NagVis
      Map of Hosts/Services/Groups in one icon (drill down)
    * Visualization/Documentation of complete IT Processes
      and Infrastructures using self drawn graphics

%package demos
Summary:        Some demo maps for NagVis
Requires:       %{name} = %{version}
Group:          Productivity/Networking/Web/Utilities

%description demos
This package contains demo maps for NagVis.

%prep
%setup -q
#find -name ".gitignore" | xargs rm
sed -i "s|\r||g" COPYING
chmod -x share/server/core/ext/php-gettext*/*.php
install -m644 %{SOURCE5} README.SuSE
%patch1 -p1
%patch2 -p1

%build

%install
mkdir -p %{buildroot}%{_datadir}/%{name}
cp -r share %{buildroot}%{_datadir}/%{name}
cp -r docs %{buildroot}%{_datadir}/%{name}/share/

# configurations belong to /etc (FHS)
install -d -m 755 %{buildroot}%{_sysconfdir}/%{name}
mkdir -p %{buildroot}%{_sysconfdir}/%{name}/{automaps,profiles}
cp -r etc/maps %{buildroot}%{_sysconfdir}/%{name}
cp -r etc/geomap %{buildroot}%{_sysconfdir}/%{name}
cp -r etc/conf.d %{buildroot}%{_sysconfdir}/%{name}
install -m 644 etc/nagvis.ini.php-sample \
    %{buildroot}%{_sysconfdir}/%{name}/nagvis.ini.php
pushd %{buildroot}%{_datadir}/%{name}
rm -rf etc
ln -s ../../..%{_sysconfdir}/%{name} etc
pushd share
mv userfiles %{buildroot}%{_sysconfdir}/%{name}/
ln -s ../../../../%{_sysconfdir}/%{name}/userfiles .
popd
popd

# install directories needed during runtime
install -d -m 755 %{buildroot}%{_bindir}
install -d -m 755 %{buildroot}%{_var}/cache/%{name}
install -d -m 755 %{buildroot}%{_var}/cache/%{name}/tmpl
install -d -m 755 %{buildroot}%{_var}/cache/%{name}/tmpl/cache
install -d -m 755 %{buildroot}%{_var}/cache/%{name}/tmpl/compile
pushd %{buildroot}%{_datadir}/%{name}/
rm -rf var
ln -s ../../../%{_var}/cache/%{name} var
ln -s ../../../../%{_var}/cache/%{name} %{buildroot}%{_datadir}/%{name}/share/var
popd

# fix nagvis config
sed "s|;base=.*|base=\"%{_datadir}/%{name}/\"|; \
     s|;htmlbase=.*|htmlbase=\"/%{name}/\"|; \
         s|var=.*|var=\"%{_var}/cache/nagvis/\"|; \
         s|mapcfg=.*|mapcfg=\"%{_sysconfdir}/%{name}/maps/\"|; \
     s|;socket=\"unix:/usr/local/nagios/var/rw/live\"|socket=\"unix:%{livestatus_socket_file}\"|; \
         s|cfg=.*|cfg=\"%{_sysconfdir}/%{name}/\"|;" \
        %{buildroot}%{_sysconfdir}/%{name}/nagvis.ini.php > %{buildroot}%{_sysconfdir}/%{name}/nagvis.ini.php.new
mv %{buildroot}%{_sysconfdir}/%{name}/nagvis.ini.php.new %{buildroot}%{_sysconfdir}/%{name}/nagvis.ini.php

# install apache config
install -Dm644 %{SOURCE2} %{buildroot}/etc/httpd/conf.d/%{name}.conf

# install nagvis-make-admin
sed -e "s@__SYSCONFDIR__@%{_sysconfdir}/%{name}@g" nagvis-make-admin > %{buildroot}%{_bindir}/nagvis-make-admin
chmod +x %{buildroot}%{_bindir}/nagvis-make-admin
install -Dm644 %{SOURCE6} %{buildroot}/%{_mandir}/man1/nagvis-make-admin.1

# install nagvis-update-script.sh
install -Dm755 %{SOURCE3} %{buildroot}%{_bindir}/nagvis-update-script
install -m644  %{SOURCE4} %{buildroot}/%{_mandir}/man1/nagvis-update-script.1

%if 0%{?suse_version} > 1020
# save some space - relink
%fdupes %{buildroot}/%{_datadir}/%{name}
%endif
find %{buildroot}%{_datadir}/%{name} -name "*.orig" -delete

%clean
rm -rf %{buildroot}

%pre
if [ -d %{_datadir}/%{name}/share/userfiles ]; then
    if [ -d %{_sysconfdir}/%{name}/userfiles ]; then
        mv %{_datadir}/%{name}/share/userfiles %{_sysconfdir}/%{name}/userfiles.rpmnew
        echo "Moved %{_datadir}/%{name}/share/userfiles to %{_sysconfdir}/%{name}/userfiles.rpmnew - please compare with %{_sysconfdir}/%{name}/userfiles and remove the .rpmnew directory"
    else
        mv %{_datadir}/%{name}/share/userfiles %{_sysconfdir}/%{name}/
        echo "Moved %{_datadir}/%{name}/share/userfiles to %{_sysconfdir}/%{name}/"
    fi
fi

%files
%defattr(-,root,root)
%license COPYING
%doc ChangeLog README README.SuSE
%config(noreplace) /etc/httpd/conf.d/%{name}.conf
%{_bindir}/*
%{_datadir}/%{name}/
%{_mandir}/man1/nagvis*.1*
%defattr(664,nagios,nagios,775)
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/maps
%dir %{_sysconfdir}/%{name}/automaps
%dir %{_sysconfdir}/%{name}/geomap
%dir %{_sysconfdir}/%{name}/conf.d
%dir %{_sysconfdir}/%{name}/userfiles
%dir %{_sysconfdir}/%{name}/profiles
%dir %{_var}/cache/%{name}
%dir %{_var}/cache/%{name}/tmpl
%dir %{_var}/cache/%{name}/tmpl/cache
%dir %{_var}/cache/%{name}/tmpl/compile
%config(noreplace) %{_sysconfdir}/%{name}/nagvis.ini.php
%config(noreplace) %{_sysconfdir}/%{name}/maps/*.cfg
%config(noreplace) %{_sysconfdir}/%{name}/geomap/*.xml
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/*.php
%config(noreplace) %{_sysconfdir}/%{name}/userfiles/*
%exclude %{_sysconfdir}/%{name}/maps/demo*
%exclude %{_sysconfdir}/%{name}/conf.d/demo.ini.php
%exclude %{_sysconfdir}/%{name}/geomap/demo-locations.csv
%exclude %{_sysconfdir}/%{name}/userfiles/images/shapes/demo*
%exclude %{_sysconfdir}/%{name}/userfiles/images/maps/demo*

%files demos
%defattr(-,root,root)
%config %{_sysconfdir}/%{name}/geomap/demo-locations.csv
%config %{_sysconfdir}/%{name}/maps/demo*
%config %{_sysconfdir}/%{name}/conf.d/demo.ini.php
%config(noreplace) %{_sysconfdir}/%{name}/geomap/demo-locations.csv
%config(noreplace) %{_sysconfdir}/%{name}/userfiles/images/shapes/demo*
%config(noreplace) %{_sysconfdir}/%{name}/userfiles/images/maps/demo*

%changelog
* Wed Oct 30 2019 J. Randall Owens <jrowens@ghiapet.net> - 1.9.16-0.1
- update to version 1.9.16
- rebuild for Fedora/GhiaPet 31

* Wed Sep 26 2018 J. Randall Owens <jrowens@ghiapet.net> - 1.9.10-1
- Adapt for GhiaPet repo
- Update to version 1.9.10

* Tue Sep 22 2015 aj@ajaissle.de
- Update to 1.8.5
  Core:
  * FIX: Livestatus Backend: Fixed exception handling when fetching
    services which are marked to be in a downtime, but the downtime
    defails can not be fetched
  * FIX: Fixed missing Action/perform/* permission for auth
    databases created with NagVis versions newer than NagVis 1.7b3.
    All auth databases which have been created before, have the
    Action/perform/* permission available. It was not possible to
    permit user not having the */*/* permission to the
    acknowledgement and custom actions via the context menu
  Frontend:
  * Multisite Snapin: Improved performance when a lot of users use
  the snapin. The snapin contents were calculated on each access in
  the past. Now, the snapin contents are cached for 15 seconds.
  This gives a good performance boost when multiple users have use
  the snapin while having access to the same set of maps.

* Wed Apr  8 2015 aj@ajaissle.de
- update to 1.8.2:
  Core:
  * Improved handling of map config files without read permissions on overview
    page and in header menu (such maps are simply hidden)
  * NagiosBP-Backend: Fixed exception when component state is not known
  Frontend:
  * FIX: Map import: Added missing validation of map name format
  * FIX: Hiding "loading..." animation when maps are disabled on overview page
  * FIX: Fixed sorting of maps on overview page
  * FIX: Fixed js exception "g_map_names" not defined when having
    header_show_states set to disabled
  * FIX: Fixed overlapping sub-hover menus for adding icons/lines

* Tue Mar 10 2015 lars@linux-schulserver.de
- update to 1.8.1:
  + fixes the broken form dialogs like user- and role management or
    the password change dialog
  + also fixes handling of external URLs within rotations
  + Cached ajax queries last no longer than 30 seconds now

* Sun Mar  1 2015 lars@linux-schulserver.de
- update to 1.8:
  + New object: Dynamic groups
    It uses livestatus filters to create a grouping object of different
    hosts or services matching this filter.
  + New object: Aggregations
    Used for displaying aggregated information, currently used together
    with the Check_MK Business Intelligence backend to display the states
    of aggregations and their elements.
  + Dynamic maps
    You can use a livestatus filter to collect a group of hosts or services
    to be shown on a map. The objects are automatically positioned in a grid
    by default, but you can reposition the objects and also change all other
    attributes of these objects.
  + Automap changes
    You can now create automaps on demand just by providing URL parameters
    which then are used to render the automap. Improved the performance and
    memory usage of the automap. The automap is now using line configuration
    parameters from the global section.
  + Sidebar changes
    All nodes having child elements are now expandable. The state of each node
    is saved per user. The sidebar can now optionally display the states of
    all maps.
  + Map zooming
    Added an optional zoom bar and mousewheel zoom handlers (ALT + wheel move).
    The zoom can now be configured to make the map fill the viewport of the
    browser. The zoom can now be configured to scale the objects or not.
  + Merge state of host, hostgroup and servicegroup cross multiple backends
    You can merge equal named objects of multiple backends together to be
    shown on NagVis maps as a single object now.
  + Gadgets
    Gadgets can now be used for all kind of statful objects. They can get more
    information about an object now, being useful even for objects without
    performance data. The gadget std_table.php has been added as example to
    give you feeling for the new options.
  + Check_MK integration
    Added a new backend to display the aggregation of Check_MK Business
    Intelligence. Dealing with the staleness value of hosts and services as a
    new sub-state. The default hover template is now showing the host and service
    tags when available. It is now possible to display tag group information
    in the hover menus.
  + Usability
    The GUI design has been consolidated to give a more consistent look n feel.
    The overview page now uses the whole screen width for showing the list of
    maps. The main configuration, map management and object add/modify dialog
    have been reworked for better usability and error handling.
  + For a detailed view on the changes since 1.7 have a look at the changelog
    of this release in /usr/share/doc/packages/nagvis/ChangeLog

* Sat Feb 15 2014 lars@linux-schulserver.de
- update to 1.7.10:
  Frontend:
  * Weathermap lines now deal with bit/byte values provided by Check_MKs
    interface checks
  * FIX: Fixed "TypeError: oLabel is null" on at least geomaps
  * FIX: Fixed shape image displaying when using external URLS
  * FIX: Hiding "Edit Map" link for "on demand" automaps
  * FIX: Fixed "modify view" dialog for "on demand" automaps
  * FIX: Fixed wrong viewport html header
  Automap:
  * Labels have now a white background to improve the text readability
  * Labels should not overlap on automaps with many hosts anymore
  * Slightly layout improvement of automaps in undirected mode
  * FIX: Rendering lines on zoomed automaps correctly
  * FIX: Fixed positions of labels on zoomed automaps

* Thu Jul 18 2013 lars@linux-schulserver.de
- dependency switch: php5-pear-xml_parser instead of php-pear-xml_parser
- move the userfiles below /etc/nagvis

* Thu Jun 13 2013 lars@linux-schulserver.de
- update to 1.7.9:
  Core:
  * Livestatus: Fixed handling of hosts/services without custom variables
  * Added option to perform privilege switch to a user with less
    permissions for viewing maps in the context of this user
  * FIX: Fixed state weight definition parsing
  * FIX: Fixed demo automap (missing programStart method in demo backend)
  Frontend:
  * FIX: Not adding textboxes to "to be updated list" anymore; This
    might have lead to objects not being reloaded on maps with
    many texboxes
  * FIX: More robust handling of broken/no perfdata handling in
    weathermap lines of type -->BW+%%-><-BW+%%--

* Wed May  1 2013 lars@linux-schulserver.de
- update to 1.7.8:
  Core:
  * Added missing program restarted check to invalidate chaches
  * Not providing auth credentials in http requests to proxy when
    none set
  Frontend:
  * Fixed "Undefined index" error when changing backend_id of maps
  * Fixed hiding of shapes during refresh (enable_refresh=1)
  * Reverted change from 1.7.5 (Weathermap lines with byte/bit values
    in labels should print human) which broke the handling for
    some plugins

* Wed Apr  3 2013 lars@linux-schulserver.de
- update to 1.7.7:
  Core:
  * Implemented "on demand" maps. Maps which only need a basic configuration
    of global parameters like automaps and geomaps can now be configured and
    created on demand by URL parameters. This mode is reached by simply
    calling the map URL without "show=" parameter and a bunch of parameters
    for the global section of the map instead.
  * Implemented center and bottom as label coordinate values which are
    automatically calculated depending on the rendered sizes
  Automap:
  * Changed default behaviour of the automap concerning the root host. By
    default NagVis uses a virtual root node which represents the monitoring
    core. It adds the parent tree and all nodes which have no parents defined
    below this node. If no parents are configured, all hosts are rendered
    below this virtual root node.
- refreshed patches

* Sun Mar  3 2013 lars@linux-schulserver.de
- update to 1.7.6
  Core:
  * Improved main configuration parsing code (should not mixup
    comments and empty lines anymore)
  * Added shinken business_impact filter to automaps (set
    shinken_features=1 in [global] section in main configuration to
    enable this feature); Thanks to Thibault Cohen for the patch)
  Frontend:
  * Added support for custom context menu actions like connecting via
    SSH, RDP, HTTP, ... to the monitored hosts.
  * FIX: Removed debug output while recalculating bandwidth of
    weathermap lines
  * FIX: Fixed height of iframes in Container objects

* Tue Feb  5 2013 lars@linux-schulserver.de
- update to 1.7.5:
  Core:
  * Allowing rgba(255,255,255,0.6) like definitions in e.g. label_style
  attributes in map configuration files
  Frontend:
  * Hiding all kind of javascript error messages automatically on next
    successful processing
  * IE below 9: Fixed invisible lines (z-index was not set)
  * Weathermap lines with byte/bit values in labels should print human
    readable traffic now
  Automap:
  * Reimplemented ignore_hosts parameter (Thanks to Thibault Cohen)

* Tue Jan  8 2013 lars@linux-schulserver.de
- update in nagvis-update-script:
  + remove 'showinlists' parameter from main config
  + do not use double quotes for the sources parameter in automap
    config
  + new options for setting user and group ownership of all default
    files after the update

* Wed Jan  2 2013 lars@linux-schulserver.de
- update to 1.7.3:
  + Extended logon module CoreLogonMultisite to support the new
    cookie format of Check_MK 1.2.1i2 and newer
  + Hiding HTTP status error messages automatically on next
    successful request
  + Bugfix: Added missing lock/unlock line middle control to BW-lines
  + Bugfix: Fixed "img" not defined js error in IE8 (Please note:
    Zoom function does not work in IE8 - IE8 event handling seems
    to be broken)
  + Bugfix: Fixed flickering hover menu on overview page when
    sidebar opened
  + Bugfix: Fixed background positioning on browser zoomed maps
  + Bugfix: Fixed javascript error when rotations are disabled
  + Bugfix: Multisite module is catching single map errors now and
    show all maps in the list regardless of the error. Maps with errors
    will be listed as UNKNOWN (orange) in the multisite snapin
  + New option source_type to configure a csv file or the used backend
    as datasource. In backend mode, the backend used on the map must
    support the new geomap functions (currently only livestatus backend).
    All hosts to be shown need the custom variables _LAT and _LONG.
    The hosts can optionally be filtered by hostgroups
  + Bugfix: Always rounding calculated coordinates, fixed negative coords
  + Bugfix: Also using source_file parameter for cache file names
    to prevent problems with multiple geomaps

* Sun Dec  9 2012 lars@linux-schulserver.de
- update to 1.7.3:
  + Livestatus-Backend: Using Columns header instead of the deprecated
    StatsGroupBy header (maybe you need to update livestatus)
  + Hiding rotations table on overview page when no rotations configured
  + Better handling of HTTP errors in ajax transactions
  + Big performance improvment when rendering object in frontend
    after adding the map zoom feature
  + Added new weathermap line type which shows only the used
    bandwidth in labels
  + Allowing empty lines in main configuration sections now
  + Set default http_timeout value to 10
  + Introduced different icons for different states in
    downtime/ack state (All iconsets need to be reworked - take
    a look at the docs for a list of
  + Introducing the "map source" feature. Take a look at the docs
    for details
  + Implemented geomaps using the new "map source" feature based on
    an Open Street Map static map API
  + Removed the special map type "automap".
    The automaps have been replaced by regular maps which use the
    "automap" source.
    Migration Notes: We do not migrate the automap config files
    automatically (beside RPM trying it's best to do with a file
    called '__automap.cfg', which will be migrated automatically).
    If you like to have them migrated please move the files from
    etc/automaps to etc/maps and add the parameter 'source="automap"'
    to the global section.
  + Automatically removing deprecated options from nagvis.ini.php
    during update. Backup files are stored in
    /etc/nagvis/auth-backup
  + Added new map config option (global section) event_on_load to
    raise frontend events also on page loading
  + Added new options event_repeat_interval and event_repeat_duration
    to configured repeated frontend events
  + Added rotations to sidebar
  + Info page shows json_encode/json_decode capability of used PHP
  + Host/Service problems can now be acknowledged from host/service
    context menus
  + many, many Bugfixes
- added nagvis-update-script to update the configuration to 1.7
- added man pages for nagvis-make-admin and nagvis-update-script
- cleanup specfile

* Mon May 28 2012 lars@linux-schulserver.de
- update to 1.6.6:
  + Includes several minor fixes in the frontend and the NagVis
    core code.
  + Added updated french language files

* Sat Nov  5 2011 lars@linux-schulserver.de
- use nagios-rpm-macros package during build to find out (and set)
  the path to the livestatus socket file

* Sun Oct 16 2011 lars@linux-schulserver.de
- update to 1.5.10:
  Core:
  + Bugfix: Supporting additive sections in both main
    configuration files
  + Bugfix: Fixed comment line mixup in main config when using
    multiple config files
  + Bugfix: Not storing config options from other config files like
    the OMD site config in nagvis.ini.php anymore
  Frontend:
  + Bugfix: Fixed problem with hover childs not being displayed and
    old childs being cached
    (Thanks to Thomas Casteleyn for reporting/fixing)

* Fri Jul 29 2011 lars@linux-schulserver.de
- fix var directory link pointing in /usr/share/nagvis/var

* Wed Jul 27 2011 lars@linux-schulserver.de
- update to 1.5.9:
  Core
  + Added show_in_multisite option to map global sections to hide
    maps from the multisite snapin
  + Bugfix: Changed index.php/config.php redirect scripts to ignore
    proto and host addresses to be able to handle https frontend
    and http backend processing when using mod_proxy
  Frontend
  + Hiding search button when not permitted to WUI
  + Bugfix: Fixed problem in default-backend change form handler

* Tue Feb 15 2011 schneemann@b1-systems.de
- changed permission on /etc/nagvis so that apache can create auth.db
  in there
- added / to "base" in nagvis.ini.php to get correct pathes

* Sun Feb  6 2011 lars@linux-schulserver.de
- update to 1.5.8:
  + please refer to /usr/share/doc/packages/nagvis/Changelog for
    a complete list of changes
- refactoring the package:
  + config is now in /etc/nagvis
  + cache files in /var/cache/nagvis
  + everything else in /usr/share/nagvis
- provide a apache conf file which needs to be enabled via
  setting NAGVIS in /etc/sysconfig/apache2

* Thu Mar 12 2009 lars@linux-schulserver.de
- update to 1.3.2:
  + @ Signs are now allowed in several strings
  + The automap hover menus did not recognize the configured backend
  + Fixed static prefix when fetching hosts without parent

* Thu Sep 11 2008 lars@linux-schulserver.de
- update to 1.3.1:
  + Fixed hardcoded path in javascript code
  + Fixed missing htmlBase path in automap javascript code
  + htmlcgi in paths and backend can now be full url
  + Fixed mysql error message when configured bad NDO instance name
  + Spaces in usernames are now allowed
  + The dbprefix can now be empty in NDO backend options

* Sun Jul 20 2008 lars@linux-schulserver.de
- update to 1.3:
  + Bugfix: Fixed transparent label border in IE (SF.net 1994891)
  + Bugfix: Fixed problem in automap child fetching algorithm
    (SF.net 1994873)
  + Bugfix: Fixed php parse error in frontend class
  + Bugfix: Fixed problem with fetching downtime end time
    (SF.net 1997091)
  + Bugfix: Fixed problem with sorting childs alphabeticaly in
    hover menus (SF.net 1997111)
  + Bugfix: Fixed problem with spaces in oldPhpVersionFixes.php
  + Bugfix: Fixed alias not being displayed in map and hostgroup
    hover menus
  + Bugfix: Fixed problem with summary state when a linked map was
    empty
  + Added plus sign to string matches (SF.net 1994579)

* Sat Apr 12 2008 lars@linux-schulserver.de
- update to 1.2.2:
  + Fixed bug with wrong only_hard_states handling
  + Fixed Logical bug in getObjects(services)
  + Spaces in format %%20 are now allowed in URLs
  + Service description is now shown in service hover menus
  + WUI: Fixed map deletion protection when map is linked in another

* Mon Dec 17 2007 lars@linux-schulserver.de
- update to 1.2
  + Recoded map rotation feature: Maps rotation can be stopped and
    restarted on demand. There is a countdown to the next
    reload/rotate in the header menu. It also can be included to
    the map in a textbox via macro. You can also define several map
    rotation pools in the main configuration.
  + Added Dynamic Favicon to increase comfort when using tabbed
    browsing
  + Added better value validation to prevent wrong configuration
  + Increased Performance (map load time) up to 50%%

* Fri Dec  7 2007 lars@linux-schulserver.de
- initial version 1.1.2
